// RobotTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RobotTest.h"
#include "RobotTestDlg.h"
#include ".\robottestdlg.h"
#include "NIDAQmxBase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CRobotTestDlg dialog



CRobotTestDlg::CRobotTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRobotTestDlg::IDD, pParent)
	, motor1(0)
	, motor2(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRobotTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT3, motor1);
	DDV_MinMaxDouble(pDX, motor1, 0, 5);
	DDX_Text(pDX, IDC_EDIT4, motor2);
	DDV_MinMaxDouble(pDX, motor2, 0, 5);
}

BEGIN_MESSAGE_MAP(CRobotTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
END_MESSAGE_MAP()


// CRobotTestDlg message handlers

BOOL CRobotTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	motor1=2;
	motor2=2;
	// Update the dialog
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRobotTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRobotTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRobotTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CRobotTestDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	// Update the variables
	UpdateData(TRUE);
	
	// Task parameters
	TaskHandle  taskHandle = 0;
	
	// Channel parameters
	CString     chan;
	float64     min;
	float64     max;

	// Timing parameters
	uInt64      samplesPerChan = 1;

	// Data write parameters
	float64     wdata1;
	float64     wdata2;
	int32       pointsWritten;
	float64     timeout = 1.0;
	

		// Channel parameters
		min = 0.0;
		max = 5.0;
		//channel AO - pin 14
		chan = "Dev1/ao0";
		//Output value
		wdata1=motor1;

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata1,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);
		
		//channel AO - pin 15
		chan = "Dev1/ao1";
		//Output value
		wdata2=motor2;

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata2,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

}

void CRobotTestDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	// Task parameters
	TaskHandle  taskHandle = 0;
	
	// Channel parameters
	CString     chan;
	float64     min;
	float64     max;

	// Timing parameters
	uInt64      samplesPerChan = 1;

	// Data write parameters
	float64     wdata1;
	float64     wdata2;
	int32       pointsWritten;
	float64     timeout = 1.0;
	

		// Channel parameters
		min = 0.0;
		max = 5.0;
		//channel AO - pin 14
		chan = "Dev1/ao0";
		//Output value
		wdata1=0;

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata1,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);
		
		//channel AO - pin 15
		chan = "Dev1/ao1";
		//Output value
		wdata2=0;

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata2,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		motor1=0;
		motor2=0;
		// Update the dialog
		UpdateData(FALSE);
}

void CRobotTestDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here
	// Update the variables
	UpdateData(TRUE);
	
	// Task parameters
	TaskHandle  taskHandle = 0;
	
	// Channel parameters
	CString     chan;
	float64     min;
	float64     max;

	// Timing parameters
	uInt64      samplesPerChan = 1;

	// Data write parameters
	float64     wdata1;
	int32       pointsWritten;
	float64     timeout = 1.0;
	

		// Channel parameters
		min = 0.0;
		max = 5.0;
		//channel AO - pin 14
		chan = "Dev1/ao0";
		//Output value
		motor1+=0.1;
		wdata1=motor1;

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata1,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		// Update the dialog
		UpdateData(FALSE);
		
}

void CRobotTestDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
	// Update the variables
	UpdateData(TRUE);
	
	// Task parameters
	TaskHandle  taskHandle = 0;
	
	// Channel parameters
	CString     chan;
	float64     min;
	float64     max;

	// Timing parameters
	uInt64      samplesPerChan = 1;

	// Data write parameters
	float64     wdata1;
	int32       pointsWritten;
	float64     timeout = 1.0;
	

		// Channel parameters
		min = 0.0;
		max = 5.0;
		//channel AO - pin 14
		chan = "Dev1/ao0";
		//Output value
		motor1-=0.1;
		wdata1=motor1;

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata1,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		// Update the dialog
		UpdateData(FALSE);
}

void CRobotTestDlg::OnBnClickedButton5()
{
	// TODO: Add your control notification handler code here
	// Update the variables
	UpdateData(TRUE);
	
	// Task parameters
	TaskHandle  taskHandle = 0;
	
	// Channel parameters
	CString     chan;
	float64     min;
	float64     max;

	// Timing parameters
	uInt64      samplesPerChan = 1;

	// Data write parameters
	float64     wdata2;
	int32       pointsWritten;
	float64     timeout = 1.0;
	

		// Channel parameters
		min = 0.0;
		max = 5.0;
		//channel AO - pin 14
		chan = "Dev1/ao1";
		//Output value
		motor2+=0.1;
		wdata2=motor2;

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata2,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		// Update the dialog
		UpdateData(FALSE);
}

void CRobotTestDlg::OnBnClickedButton6()
{
	// TODO: Add your control notification handler code here
	// Update the variables
	UpdateData(TRUE);
	
	// Task parameters
	TaskHandle  taskHandle = 0;
	
	// Channel parameters
	CString     chan;
	float64     min;
	float64     max;

	// Timing parameters
	uInt64      samplesPerChan = 1;

	// Data write parameters
	float64     wdata2;
	int32       pointsWritten;
	float64     timeout = 1.0;
	

		// Channel parameters
		min = 0.0;
		max = 5.0;
		//channel AO - pin 14
		chan = "Dev1/ao1";
		//Output value
		motor2-=0.1;
		wdata2=motor2;

		DAQmxBaseCreateTask("",&taskHandle);
		DAQmxBaseCreateAOVoltageChan(taskHandle,chan,"",min,max,DAQmx_Val_Volts,NULL);
		DAQmxBaseStartTask(taskHandle);
		DAQmxBaseWriteAnalogF64(taskHandle,samplesPerChan,0,timeout,DAQmx_Val_GroupByChannel,&wdata2,&pointsWritten,NULL);
		DAQmxBaseStopTask(taskHandle);
		DAQmxBaseClearTask (taskHandle);

		// Update the dialog
		UpdateData(FALSE);
}
